<template>
  <img v-if="image" class="mx-auto w-full sm:w-full image-preview" loading="lazy" :src="image" alt="">
  <LoadsSpinner v-if="loading" small/>
</template>

<script>
import LoadsSpinner from "./Loads-spinner.vue";
import {ref, onMounted} from 'vue'
export default {
  name: "productImage",
  components: {LoadsSpinner},
  props: {
    image: {
      required: true
    }
  },
  setup() {
    const loading = ref(false)
    function waitLoadingImage() {
      loading.value = true
      // Получение картинок и запись их в переменную
      let images = document.querySelectorAll('img');

      // Объявление переменной и присваивание ей результат работы функции
      let imageInterval = setInterval(() => {
        // Создаем условие для очистки работы метода setInterval
        if (images[0].complete) {
          // Очищаем переменную imageInterval
          clearInterval(imageInterval);
          loading.value = false
        }
      }, 50)
    }
    onMounted(()=>{
      waitLoadingImage()
    })
    return {
      loading
    }
  }
}
</script>

<style scoped lang="scss">
.image-wrap {
  min-width: 100px;
  min-height: 100px;
  position: relative;
  max-width: 100%;
  div {
    position: absolute;
    width: 20px;
    height: 20px;
    top: calc(50% - 10px);
    left: calc(50% - 10px);
  }
  .image-preview {
    max-width: 100%!important;
  }
}
</style>
